Camera = {}

function Camera:new(tracking,screenSize,mapSize)
	local object = 
	{
		pTracked=tracking,
		center={screenSize[1]/2,screenSize[2]/2},
		--1 arriba, 2 derecha, 3 abajo, 4 izquierda
		borders={0,0,0,0},
		map=mapSize
	}
	setmetatable(object,{__index=Camera})
	return object
end

function Camera:update(dt,playerTracked)

	--Actualización del centro de la cámara
	self.pTracked=playerTracked
	
	--Obtiene los bordes de la cámara en coordenadas del mapa
	self.borders[1]=self.pTracked.posY-self.center[2]
	self.borders[2]=self.pTracked.posX+self.pTracked.width+self.center[1]
	self.borders[3]=self.pTracked.posY+self.pTracked.height+self.center[2]
	self.borders[4]=self.pTracked.posX-self.center[1]

end

function Camera:onRange(object)
	--Determina si el objecto se encuentra dentro del rango de visión de la cámara
	if (object.posX<self.borders[2] and object.posX>self.borders[4]) or (object.posX+object.width<self.borders[2] and object.posX+object.width>self.borders[4]) then
		if (object.posY>self.borders[1] and object.posY<self.borders[3]) or (object.posY+object.height>self.borders[1] and object.posY+object.height<self.borders[3]) then
			return true
		end
	end
	return false
end
function Camera:inside(inMap)
	if inMap.posX<self.pTracked.posX and inMap.width>self.pTracked.posX+self.pTracked.width then
		if inMap.posY<self.pTracked.posY and inMap.height>self.pTracked.posY+self.pTracked.height then
			return true
		end
	end
	return false
end

function Camera:relativePosition(object)
	--Da las coordenadas de pantalla para dibujar el objeto recibido. Si el objeto no puede ser dibujado
	--se retornan números negativos
	relPos={-1,-1}
	if self:onRange(object) then	
		relPos[1]=object.posX-self.borders[4]
		relPos[2]=object.posY-self.borders[1]
	end
	return relPos
end
function Camera:mapRelativePosition(inMap)
	--Da las coordenadas de pantalla para dibujar el objeto recibido. Si el objeto no puede ser dibujado
	--se retornan números negativos
	relPos={-1,-1}
	if self:inside(inMap) then	
		relPos[1]=inMap.posX-self.borders[4]
		relPos[2]=inMap.posY-self.borders[1]
	end
	return relPos
end