function love.load()
	require "player"
	require "map"
	require "castle"
	require "camera"
	
	Keyboard=love.keyboard
	Graphics=love.graphics
	
	--variables para el delay de las teclas arriba y abajo en el menú principal
	keyDelay=10
	keyDelayTimer=0

	--variables del menú principal
	option=1
	options={"1-Start","2-Achievements","3-Options","4-Exit"}
	optionSelected=0
	
	--obtener la resolución de la ventana
	screenW,screenH=love.window.getDimensions()
	
	--Saltos de línea y posición para los textos del menú principal
	nLine=12
	sTextPos={200,200}
	
	--Variables del mapa
	actualMap=Map:new(1)
	
	--Variables del castillo
	
	--Variables del personaje
	playerDir=5
	playerOne=Player:new(actualMap.castles[1].posX,actualMap.castles[1].posY+96)
	playerIsMoving=false
	
	--Variables de las cámaras
	actualCamera=Camera:new(playerOne,{screenW,screenH},{actualMap.width,actualMap.height})
	
	--Variables genéricas temporales
	tempVector={}
	
end

function love.draw()
	
	--sección en ejecución. 0 menú principal, 1-4 variable options
	Graphics.print("Running: "..optionSelected)
	
	--Opciones del menú principal
	if optionSelected==0 then
		--resolucion y monitores
		Graphics.print(("display res: %d x %d"):format(screenW,screenH),4,10)
		--delay de las teclas arriba y abajo en el menú principal
		Graphics.print(("KeyDelayTimer: %d"):format(keyDelayTimer),4,22)
		for pos,text in ipairs(options) do
			if pos==option then
				Graphics.setColor(255,0,0)
			end
			Graphics.print(text,sTextPos[1],sTextPos[2])
			sTextPos[2]=sTextPos[2]+12
			Graphics.setColor(0,0,255)
		end
		sTextPos[2]=200
	end
	
	--En juego
	if optionSelected==1 then
		
		--dibujar el mapa		
		tempVector=actualCamera:mapRelativePosition(actualMap)
		if tempVector[1]~=-1 and tempVector[2]~=-1 then
			Graphics.setColor(255,0,255)
			Graphics.rectangle("fill",tempVector[1],tempVector[2],actualMap.width,actualMap.height)
		end
		
		
		
		Graphics.setColor(255,255,255)
		Graphics.print("XSpeed "..playerOne.actualXSpeed.." YSpeed "..playerOne.actualYSpeed,600,40)
		
		Graphics.print(("Player one pos: X %d Y %d  DIRECTION: %d"):format(playerOne.posX,playerOne.posY,playerDir),4,500)
		if playerIsMoving then
			Graphics.print("Player is moving...",4,512)
		else
			Graphics.print("Player is not moving...",4,512)
		end
		
		--Datos de la cámara
		Graphics.print(("Camera borders: TOP%d RIGHT%d BOTTOM%d LEFT%d"):format(actualCamera.borders[1],actualCamera.borders[2],actualCamera.borders[3],actualCamera.borders[4]),4,530)
		Graphics.print("Window size: width "..screenW.." height"..screenH,4,542)
		
		--Dibujar jugador
		Graphics.rectangle("fill",actualCamera.center[1],actualCamera.center[2],16,32)
		
		--Dibujar castillo
		for pos,actualCastle in ipairs(actualMap.castles) do
			tempVector=actualCamera:relativePosition(actualCastle)
			if tempVector[1]~=-1 and tempVector[2]~=-1 then
				Graphics.setColor(255,255,0)
				Graphics.rectangle("fill",tempVector[1],tempVector[2],actualCastle.width,actualCastle.height)
			end
			if actualCamera:onRange(actualCastle) then
				Graphics.print(actualCastle.name.." should be visible",300,36)
			else
				Graphics.print(actualCastle.name.." should NOT be visible",300,36)
			end
			Graphics.print("X"..actualCastle.posX.." Y"..actualCastle.posY,300,44)
		end
	end
end

function love.update(dt)

	--Menú principal
	if optionSelected==0 then
		if keyDelayTimer==0 then
			if Keyboard.isDown("up") and option>1 then
				option=option-1
				keyDelayTimer=1
			end
			if Keyboard.isDown("down") and option<4 then
				option=option+1
				keyDelayTimer=1
			end
		else
			--Delay para las teclas arriba y abajo
			keyDelayTimer=keyDelayTimer+1
			if keyDelayTimer>keyDelay then
				keyDelayTimer=0
			end
		end
		if Keyboard.isDown("return") then
			optionSelected=option
		end
	end
	
	--EnJuego
	if optionSelected==1 then
		
		actualCamera:update(dt,playerOne)
		
		--Volver al menú principal
		if Keyboard.isDown("escape") then
			optionSelected=0
		end
		
		--direcciones de movimiento
		playerDir=5
		if Keyboard.isDown("up") then playerDir=playerDir+3 end
		if Keyboard.isDown("down") then playerDir=playerDir-3 end
		if Keyboard.isDown("right") then playerDir=playerDir+1 end
		if Keyboard.isDown("left") then playerDir=playerDir-1 end
		playerIsMoving=playerOne:update(dt,playerDir,{100,100,100,100})
		
	end
	
	--Salir
	if optionSelected==4 then
		love.event.quit()
	end
end